<?php
/**
 * FRED2
 *
 * @author fish <fish@archa.cz>
 * @package viper
 * @version 2.0
 *
 */
/**
 * trida nahrazujici red_h
 * @package Fred
 *
 */
class Fred2 {
  /**
   * static $RED_ATT_DIR
   * @static string adresar s prilohama
   */
  static $RED_ATT_DIR="./data";
  /**
   * static $RED_ATT_DIR_WEB
   * @static string adresar s prilohama na webu
   */
  static $RED_ATT_DIR_WEB="data";

  /**
   * variable $TblPrefix
   * @static string prefix tabulek
   */
  static $TblPrefix="";

  /**
   * static $dbh
   * @static object database handle
   */
  static $dbh=NULL;
  /**
   * variable $dbhe
   * @protected object extended db handle
   */
  protected $dbhe=NULL;
  /**
   * variable $ClassType
   * @static array typy trid
   */
  static $ClassType = array(  "TC_NUMBER" =>  1,
                              "TC_BOOL"   =>  2,
                              "TC_STEXT"  =>  3,
                              "TC_LTEXT"  =>  4,
                              "TC_FILE"   =>  5,
                              "TC_LIST"   =>  6,
                              "TC_FILE2"  =>  7
                              );

  static $FORCE_PNG_8BIT=FALSE;

  protected $ClassIDCache=NULL;
  protected $CClassIDCache=NULL;
  protected $CatIDCache=NULL;

  // {{{ constructor
  /**
   * Constructor
   *
   * @param handle $dbh
   * @return boolean
   */
  function __construct($dbh,$TblPrefix=""){
    self::$TblPrefix=$TblPrefix;
    $this->dbh=$dbh;
    $dbhe=$dbh->loadModule('Extended');
    if(PEAR::isError($dbhe)){
      echo $dbhe->getUserInfo()._nl;
    } else {
      $this->dbhe=&$dbhe;
    }
    return(TRUE);
  }
  // }}} constructor

  function getClassID($SysName,$HardSQL=FALSE){
//     $SysName=strtoupper($SysName);
    if(!isset($ClassIDCache) || $HardSQL){
      $query ="SELECT UPPER(sysname),id FROM ".self::$TblPrefix."classes ";
      $query.="ORDER BY sysname ";
      if(!PEAR::isError($res=$this->dbhe->getAssoc($query))){
        $ClassIDCache=&$res;
      }
    }
    if(isset($ClassIDCache[$SysName])){
      return($ClassIDCache[$SysName]);
    } else {
      return(0);
    }
  }

  function getCClassID($SysName,$HardSQL=FALSE){
//     $SysName=strtoupper($SysName);
    if(!isset($CClassIDCache) || $HardSQL){
      $query ="SELECT UPPER(sysname),id FROM ".self::$TblPrefix."cclasses ";
      $query.="ORDER BY sysname ";
      if(!PEAR::isError($res=$this->dbhe->getAssoc($query))){
        $CClassIDCache=&$res;
      }
    }
    if(isset($CClassIDCache[$SysName])){
      return($CClassIDCache[$SysName]);
    } else {
      return(0);
    }
  }

  function getCatID($SysName,$HardSQL=FALSE){
    if(!isset($CatIDCache) || $HardSQL){
      $query ="SELECT sysname,id FROM ".self::$TblPrefix."cats ";
      $query.="ORDER BY sysname ";
      if(!PEAR::isError($res=$this->dbhe->getAssoc($query))){
        $CatIDCache=&$res;
      }
    }
    if(isset($CatIDCache[$SysName])){
      return($CatIDCache[$SysName]);
    } else {
      return(0);
    }
  }

  function GetCatInfo($cat_id=0){
    $cat_id*=1;
    $retval=array();

    $query ="SELECT id, ";
    $query.="name, ";
    $query.="sysname, ";
    $query.="comment, ";
    $query.="type, ";
    $query.="id_parent ";
    $query.="FROM ".self::$TblPrefix."cats ";
    $query.="WHERE id=".$this->dbh->quote($cat_id)." ";
    if(PEAR::isError($retval=$this->dbhe->getRow($query))){
      $retval=array();
    }
    return($retval);
  }

  function GetCatClass($IdCat,$CatClasses=array(),$ById=FALSE){
    $IdCat*=1;
    if(is_string($CatClasses)){
      $CatClasses=array($CatClasses);
    }
    $CatClassesID=array();
    foreach($CatClasses as $SysName){
      if(!$ById){
        $CatClassesID[]=$this->getCClassID($SysName);
      } else {
        $CatClassesID[]=$SysName;
      }
    }
    $query ="SELECT ";
    $query.="".self::$TblPrefix."cat_cclasses.id, ";
    $query.="".self::$TblPrefix."cat_cclasses.id_class, ";
    $query.="cls_tbl.name, ";
    $query.="cls_tbl.sysname, ";
    $query.="cls_tbl.id_type, ";
    $query.="cls_tbl.comment AS cls_comment, ";
    $query.="".self::$TblPrefix."cat_cclasses.val, ";
    $query.="".self::$TblPrefix."cat_cclasses.comment AS val_comment ";
    $query.="FROM ".self::$TblPrefix."cat_cclasses ";
    $query.="LEFT JOIN ".self::$TblPrefix."cclasses AS cls_tbl ON cls_tbl.id=cat_cclasses.id_class ";
    if(count($CatClassesID)){
      $query.="WHERE ".self::$TblPrefix."cat_cclasses.id_class IN (".implode(",",$CatClassesID).") ";
    } else {
      $query.="WHERE 1 ";
    }
    $query.="AND ".self::$TblPrefix."cat_cclasses.id_cat=".$this->dbh->quote($IdCat)." ";
    $query.="ORDER BY cls_tbl.prior,".self::$TblPrefix."cat_cclasses.id_class,".self::$TblPrefix."cat_cclasses.id ";
//     echo $query._nl;
    if(!PEAR::isError($res=$this->dbhe->getAssoc($query))){
//     pre_print($res);
      return($res);
    } else {
      return(array());
    }
  }

  function getTXTClassID($IdTxtClass=0){
    $query ="SELECT id_class FROM ".self::$TblPrefix."item_classes ";
    $query.="WHERE id=".$this->dbh->quote($IdTxtClass)." ";
    if(!PEAR::isError($res=$this->dbhe->getOne($query))){
      return($res);
    } else {
      return(FALSE);
    }
  }

  function getClassInfo($IdClass=0,$ClassCats=array(),$OrderBy=array("prior","name")){
    $IdClass*=1;
    if(is_int($ClassCats)){
      $ClassCats=array($ClassCats);
    }
    if(count($ClassCats)){
      foreach($ClassCats as &$Cat){
        $Cat*=1;
      }
    }
    $query ="SELECT ".self::$TblPrefix."classes.id,".self::$TblPrefix."classes.id_type,".self::$TblPrefix."class_types.name AS id_type_name,".self::$TblPrefix."classes.name,".self::$TblPrefix."classes.sysname,".self::$TblPrefix."classes.comment,".self::$TblPrefix."classes.prior,".self::$TblPrefix."classes.univ FROM ".self::$TblPrefix."classes ";
    if(count($ClassCats)){
      $query.="LEFT JOIN ".self::$TblPrefix."cats4class ON ".self::$TblPrefix."cats4class.id_cls=".self::$TblPrefix."classes.id ";
    }
    $query.="LEFT JOIN ".self::$TblPrefix."class_types ON ".self::$TblPrefix."class_types.id=".self::$TblPrefix."classes.id_type ";
    $query.="WHERE 1 ";
    if(count($ClassCats)){
      $query.="AND (".self::$TblPrefix."cats4class.id_cat IN (".implode(",",$ClassCats).") OR ".self::$TblPrefix."classes.univ=1) ";
    }
    if($IdClass!=0){
      $query.="AND ".self::$TblPrefix."classes.id=".$this->dbh->quote($IdClass)." ";
    }
    $query.="GROUP BY ".self::$TblPrefix."classes.id ";
    if(count($OrderBy)){
      foreach($OrderBy as &$OB){
        $OB=$this->dbh->quoteIdentifier($OB);
      }
      $query.="ORDER BY ".implode(",",$OrderBy)." ";
    }
//     echo $query._nl;

    $ClassInfo=FALSE;
    if($IdClass!=0){
      if(!PEAR::isError($res=$this->dbhe->getRow($query))){
        $ClassInfo=&$res;
      } else {
        echo __FILE__."::".__LINE__.":: ".$res->getUserInfo()._nl;
      }
    } else {
      if(!PEAR::isError($res=$this->dbhe->getAssoc($query))){
        $ClassInfo=&$res;
      } else {
        echo __FILE__."::".__LINE__.":: ".$res->getUserInfo()._nl;
      }
    }
    return($ClassInfo);
  }

  function getCClassInfo($IdCClass=0){
    $IdCClass*=1;
    $query ="SELECT ".self::$TblPrefix."cclasses.id,".self::$TblPrefix."cclasses.id_type,".self::$TblPrefix."class_types.name AS id_type_name,".self::$TblPrefix."cclasses.name,".self::$TblPrefix."cclasses.sysname,".self::$TblPrefix."cclasses.comment,".self::$TblPrefix."cclasses.prior,".self::$TblPrefix."cclasses.univ FROM ".self::$TblPrefix."cclasses ";
    $query.="LEFT JOIN ".self::$TblPrefix."class_types ON ".self::$TblPrefix."class_types.id=".self::$TblPrefix."cclasses.id_type ";
    $query.="WHERE 1 ";
    if($IdCClass!=0){
      $query.="AND ".self::$TblPrefix."cclasses.id=".$this->$dbh->quote($IdClass)." ";
    }
    $query.="GROUP BY ".self::$TblPrefix."cclasses.id ";
    $query.="ORDER BY prior,name ";

    $ClassInfo=FALSE;
    if(!PEAR::isError($res=$this->dbhe->getRow($query))){
      $ClassInfo=&$res;
    }
    return($ClassInfo);
  }

  function getClassVals($IdClass){
    $query ="SELECT id,id_cls,val,comment FROM ".self::$TblPrefix."class_values ";
    $query.="WHERE id_cls=".$this->dbh->quote($IdClass)." ";
    $query.="ORDER BY val ";
    if(!PEAR::isError($res=$this->dbhe->getAssoc($query))){
      return($res);
    } else {
      echo $res->getUserInfo()._nl;
      return(FALSE);
    }
  }

  function getCClassVals($IdClass){
    $query ="SELECT id,id_cls,val,comment FROM ".self::$TblPrefix."class_values ";
    $query.="WHERE id_cls=".$this->dbh->quote($IdClass)." ";
    $query.="ORDER BY val ";
    if(!PEAR::isError($res=$this->dbhe->getAssoc($query))){
      return($res);
    } else {
      return(FALSE);
    }
  }

  function getCats4TXT($IdTXT){
    $query ="SELECT id_cat FROM ".self::$TblPrefix."cats4item ";
    $query.="WHERE id_item=".$this->dbh->quote($IdTXT)." ";
    if(!PEAR::isError($res=$this->dbhe->getCol($query))){
      return($res);
    } else {
      reutnr(array());
    }
  }

  function GetTXTClass($IdTXT,$TXTClasses=array(),$ById=FALSE){
    $IdTXT*=1;
    if(is_string($TXTClasses)){
      $TXTClasses=array($TXTClasses);
    }
    $TXTClassesID=array();
    foreach($TXTClasses as $SysName){
      if(!$ById){
        $TXTClassesID[]=$this->getClassID($SysName);
      } else {
        $TXTClassesID[]=$SysName;
      }
    }
    $query ="SELECT ";
    $query.="".self::$TblPrefix."item_classes.id, ";
    $query.="".self::$TblPrefix."item_classes.id_class, ";
    $query.="cls_tbl.name, ";
    $query.="cls_tbl.sysname, ";
    $query.="cls_tbl.id_type, ";
    $query.="cls_tbl.comment AS cls_comment, ";
    $query.="".self::$TblPrefix."item_classes.val, ";
    $query.="".self::$TblPrefix."item_classes.comment AS val_comment ";
    $query.="FROM ".self::$TblPrefix."item_classes ";
    $query.="LEFT JOIN ".self::$TblPrefix."classes AS cls_tbl ON cls_tbl.id=".self::$TblPrefix."item_classes.id_class ";
    if(count($TXTClassesID)){
      $query.="WHERE ".self::$TblPrefix."item_classes.id_class IN (".implode(",",$TXTClassesID).") ";
    } else {
      $query.="WHERE 1 ";
    }
    $query.="AND ".self::$TblPrefix."item_classes.id_item=".$this->dbh->quote($IdTXT)." ";
    $query.="ORDER BY cls_tbl.prior,".self::$TblPrefix."item_classes.id_class,".self::$TblPrefix."item_classes.id ";
    // echo $query._nl;
    if(!PEAR::isError($res=$this->dbhe->getAssoc($query))){
      return($res);
    } else {
      //echo $res->getUserInfo()._nl;
      return(array());
    }
  }

  function AttDir(){
    return(self::$RED_ATT_DIR);
  }

  function AttDirWeb(){
    return(self::$RED_ATT_DIR_WEB);
  }

  function ModTXTClass($IdTxtClass=0,$ClsVal=NULL,$ClsComment=NULL){
/*    $query ="SELECT classes.id,classes.id_type FROM (classes,item_classes) ";
    $query.="WHERE item_classes.id=".$this->dbh->quote($IdTxtClass)." AND classes.id=item_classes.id_class ";
    if(!PEAR::isError($ClassInfo=$this->dbhe->getRow($query))){*/
    if(($TxtCId=$this->getTXTClassID($IdTxtClass))!==FALSE){
      if($ClassInfo=$this->getClassInfo($TxtCId)){
        if($ClassInfo["id_type"]==self::$ClassType["TC_LIST"] && isset($ClsVal) && preg_match("/^(\d+)/",$ClsVal,$ReTmp)){
          if($ReTmp[1]!=0){
            $query ="SELECT `val`,`comment` FROM ".self::$TblPrefix."class_values ";
            $query.="WHERE id_cls=".$this->dbh->quote($ClassInfo["id"])." ";
            $query.="AND id=".$this->dbh->quote($ReTmp[1])." ";
//             echo $query._nl;
            if(!PEAR::isError($res=$this->dbhe->getRow($query))){
              $ClsVal=$res["val"];
              // je to editable, nebo prepiseme defautni hodnotou?
              $Editable = false;
              if (!empty($ClassInfo["comment"])) {
                $Params = explode('|',$ClassInfo["comment"]);
                if (in_array('editable_comment', $Params)) {
                  $Editable = true;
                }
              }
              if (!$Editable) {
                $ClsComment=$res["comment"];
              }
            } else {
              return(FALSE);
            }
          } else {
            $ClsVal="";
          }
        }
      }
      $query="";
      if(isset($ClsVal)){
        $query.=", `val`=".$this->dbh->quote($ClsVal)." ";
      }
      if(isset($ClsComment)){
        $query.=", `comment`=".$this->dbh->quote($ClsComment)." ";
      }
      if($query!=""){
        $query ="UPDATE item_classes SET ".substr($query,1)." ";
        $query.="WHERE id=".$this->dbh->quote($IdTxtClass)." ";
//         echo $query._nl;
        if(!PEAR::isError($res=$this->dbhe->getAssoc($query))){
          return(TRUE);
        } else {
          echo $res->getUserInfo()._nl;
          return(FALSE);
        }
      }
    } else {
      return(FALSE);
    }
  }


// RESIZE OBRAZKU

  protected $loadimg_status=FALSE;

  function LoadPNG($imgname)
    {
      $im =@imagecreatefrompng ($imgname); /* Attempt to open */
      $this->loadimg_status=TRUE;
      if (!$im)
        { /* See if it failed */
        $this->loadimg_status=FALSE;
        $im  = imagecreate (150, 30); /* Create a blank image */
        $bgc = imagecolorallocate ($im, 255, 255, 255);
        $tc  = imagecolorallocate ($im, 0, 0, 0);
        imagefilledrectangle ($im, 0, 0, 150, 30, $bgc);

        /* Output an errmsg */
        imagestring ($im, 1, 5, 5, "Error loading\n".$imgname, $tc);
      }
    return $im;
    }


  function LoadJPG($imgname)
    {
      $im = @imagecreatefromjpeg ($imgname); /* Attempt to open */
      $this->loadimg_status=TRUE;
      if (!$im)
        { /* See if it failed */
        $this->loadimg_status=FALSE;
        $im  = imagecreate (150, 30); /* Create a blank image */
        $bgc = imagecolorallocate ($im, 255, 255, 255);
        $tc  = imagecolorallocate ($im, 0, 0, 0);
        imagefilledrectangle ($im, 0, 0, 150, 30, $bgc);
        /* Output an errmsg */
        imagestring ($im, 1, 5, 5, "Error loading\n".$imgname, $tc);
      }
    return $im;
    }


  protected $IMG_RES_TMP="";
  protected $IMG_RES="";

  function ResizeCopy($src,$dstsize=100,$dst="",$upsize=0,$qua=60,$fsize=0,$max_img_size=0,$fixboundary=0,$br=0,$bg=0,$bb=0){
    preg_match("/^((\.?\/?[^\/]+\/)*)([^\/]+)\.([^\.]+)$/",$src,$tmp);
    if($dst!=""){
      preg_match("/^((\.?\/?[^\/]+\/)*)([^\/]+)\.([^\.]+)$/",$dst,$tmp2);
      if(($tmp2[3]=="") or ($tmp2[4]=="")){
        $dst="";
      }
    }

    $fpath=$tmp[1];
    $fname=$tmp[3];
    $fext=$tmp[4];

    if($dstsize==0){
      $dstsize=100;
    }

    if($qua==0){
      $qua=60;
    }

    if($qua<0) $qua=60;
    if($qua>100) $qua=100;

    if($dst==""){
      $dst=$fpath.$fname."_".$dstsize.".".$fext;
    }

    // im je orig image
    if(strtolower($fext)=="jpg" || strtolower($fext)=="jpeg"){
      $im = $this->LoadJPG($src);
    }
    if(strtolower($fext)=="png"){
      $im = $this->LoadPNG($src);
    }

    if($im){
      // *************************************    ulozeni resized image
      $mp = max(imagesx($im),imagesy($im));
      if(strpos($dstsize,"x")===FALSE){
        //resize podle jednoho parametru
        $wantx=$dstsize;
        $wanty=$dstsize;
        if(($mp>$dstsize) or ($upsize!=0))
          {
          $pomer  = $dstsize/$mp;
          $bx     = round(imagesx($im)*$pomer);
          $by     = round(imagesy($im)*$pomer);
          }
        else
          {
          $pomer  = 1;
          $bx     = round(imagesx($im)*$pomer);
          $by     = round(imagesy($im)*$pomer);
          }
      } else {
        $tmps=explode("x",$dstsize);
        $tmps[0]=$tmps[0]*1;
        $tmps[1]=$tmps[1]*1;
        $wantx=$tmps[0]*1;
        $wanty=$tmps[1]*1;
        //resize podle sirka x vyska

        if($upsize==0 && (imagesx($im)<$tmps[0] || $tmps[0]==0) && (imagesy($im)<$tmps[1] || $tmps[1]==0)){
          //obrazek je mensi nez pozadovana velikost, ale neni zvolen upsize, tak ho necham byt
          $bx=imagesx($im);
          $by=imagesy($im);
        } else {
          if($fsize){
            //natvrdo zmeni velikost i bez zachovani pomeru stran
            $bx=$tmps[0];
            $by=$tmps[1];
          } else {
            if($tmps[0]==0){
              //resize podle y
              $pomer  = $tmps[1]/imagesy($im);
            } else if($tmps[1]==0){
              //resize podle x
              $pomer  = $tmps[0]/imagesx($im);
            } else {
              //udelam resize podle vetsi z originalnich stran na odpovidajici pozadovanou velikost
              if(imagesx($im)>=imagesy($im)){
                $pomer  = $tmps[0]/imagesx($im);
                if(imagesy($im)*$pomer>$tmps[1]){
                  $pomer=$tmps[1]/imagesy($im);
                }
              } else {
                $pomer  = $tmps[1]/imagesy($im);
                if(imagesx($im)*$pomer>$tmps[0]){
                  $pomer=$tmps[0]/imagesx($im);
                }
              }
            }
            $bx = round(imagesx($im)*$pomer);
            $by = round(imagesy($im)*$pomer);
          }
        }

      }
      if(($isize=filesize($src))===false){
        $isize=$max_img_size+10;
      }
//    $tcolor=imageistruecolor($im);
      $tcolor=1;
      $bx_dst=$bx;$by_dst=$by;
      if($fixboundary){
//        echo "fix"._nl;
        $bx_dst=max($bx,$wantx);
        $by_dst=max($by,$wanty);
      }
      $this->IMG_RES_TMP=($bx_dst*1)."x".($by_dst*1);
      if(($bx_dst!=imagesx($im)) or ($by_dst!=imagesy($im)) or ($isize>$max_img_size)){
        if(!$tcolor || ($fext=="png" && self::$FORCE_PNG_8BIT)){
          $bigimg = @imagecreate($bx_dst, $by_dst);
        } else {
          $bigimg = @imagecreatetruecolor($bx_dst, $by_dst);
        }
        if($bigimg){
          $bgColor = imagecolorallocate($bigimg, $br,$bg,$bb);
          imagefilledrectangle($bigimg, 0, 0, $bx_dst, $by_dst, $bgColor);
          imagecopyresampled($bigimg,$im,round(($bx_dst-$bx)/2),round(($by_dst-$by)/2),0,0,$bx,$by,imagesx($im),imagesy($im));
          if($fext=="png"){
            imagepng($bigimg,$dst);
          } else {
            imagejpeg($bigimg,$dst,$qua);
          }

          imagedestroy($bigimg);
        }
      }
      imagedestroy($im);
    }
    return($this->loadimg_status);
  }

// ^--- resize

//    HLAVNI OBRAZKO-KOPIROVACI FUNKCE
  function ResizeImg($soubor="",$params=""){
    $this->IMG_RES="";
    if($params!=""){
      $imgsizes=array();
      $is=array();
      do{
        if($params!=""){
          preg_match("/(#?[rRtTqQuUfFcCmMzZ]{1}[0-9]+(x[0-9]+)?(@[0-9]+)?)([^r^R^t^T^q^Q^u^U^f^F^0-9^c^C^m^M^z^Z]?)/",$params,$is);
//          pre_print($is);
          if(isset($is[0])) $params=preg_replace("/".$is[0]."/","",$params);
          if(!isset($is[1])) $is[1]="";
        } else {
          $is[1]="";
        }
        if(isset($is[1]) and $is[1]!=""){
          $imgsizes[]=$is[1];
        }
      } while ($is[1]!="");
      if(count($imgsizes)!=0){
        $qual=60;
        $upsiz=0;
        $br=0;$bg=0;$bb=0;
        $forcesiz=0;
        foreach($imgsizes as $oimg){
          if(preg_match("/[cC](\d+)/",$oimg,$spar)){
            $br=$spar[1];
          }
          if(preg_match("/[zZ](\d+)/",$oimg,$spar)){
            $bg=$spar[1];
          }
          if(preg_match("/[mM](\d+)/",$oimg,$spar)){
            $bb=$spar[1];
          }
          if(preg_match("/[qQ](\d+)/",$oimg,$spar)){
            $qual=$spar[1];
          }
          if(preg_match("/[uU](\d{1})/",$oimg,$spar)){
            $upsiz=$spar[1];
          }
          if(preg_match("/[fF](\d{1})/",$oimg,$spar)){
            $forcesiz=$spar[1];
          }
        }
        foreach($imgsizes as $oimg){
          if(preg_match("/^[rR](\d+(x\d+)?(@[0-9]+)?)/",$oimg,$spar)){
            $tmp=explode("@",$spar[1]);
            if(!isset($tmp[1])){ $tmp[1]=0; }
            if($retval=$this->ResizeCopy($soubor,$tmp[0],$soubor,$upsiz,$qual,$forcesiz,$tmp[1]*1024)){
              $this->IMG_RES.=$this->IMG_RES_TMP.",";
            }
          }
          if(preg_match("/^[tT](\d+(x\d+)?(@[0-9]+)?)/",$oimg,$spar)){
            $tmp=explode("@",$spar[1]);
            if(!isset($tmp[1])){ $tmp[1]=0; }
            if($retval=$this->ResizeCopy($soubor,$tmp[0],"",$upsiz,$qual,$forcesiz,$tmp[1]*1024)){
              $this->IMG_RES.=$this->IMG_RES_TMP.",";
            }
          }

          if(preg_match("/^#[rR](\d+(x\d+)?(@[0-9]+)?)/",$oimg,$spar)){
            $tmp=explode("@",$spar[1]);
            if(!isset($tmp[1])){ $tmp[1]=0; }
            if($retval=$this->ResizeCopy($soubor,$tmp[0],$soubor,$upsiz,$qual,$forcesiz,$tmp[1]*1024,1,$br,$bg,$bb)){
              $this->IMG_RES.=$this->IMG_RES_TMP.",";
            }
          }
          if(preg_match("/^#[tT](\d+(x\d+)?(@[0-9]+)?)/",$oimg,$spar)){
            $tmp=explode("@",$spar[1]);
            if(!isset($tmp[1])){ $tmp[1]=0; }
            if($retval=$this->ResizeCopy($soubor,$tmp[0],"",$upsiz,$qual,$forcesiz,$tmp[1]*1024,1,$br,$bg,$bb)){
              $this->IMG_RES.=$this->IMG_RES_TMP.",";
            }
          }

        }
      }
      $this->IMG_RES=preg_replace("/,$/","",$this->IMG_RES);
      return($retval);
    } else {
      return(TRUE);
    }
  }

  function AddTXTClass($IdTxt,$IdClass,$ClsVal="",$ClsComment=""){
    $query ="INSERT INTO item_classes(id_item,id_class,val,comment) ";
    $query.="SELECT ".$this->dbh->quote($IdTxt).",classes.id,".$this->dbh->quote($ClsVal).",".$this->dbh->quote($ClsComment)." ";
    $query.="FROM ".self::$TblPrefix."classes WHERE ".self::$TblPrefix."classes.id=".$this->dbh->quote($IdClass)." ";
    if(!PEAR::isError($this->dbh->query($query))){
      return($this->dbh->lastInsertID());
    } else {
      return(FALSE);
    }
  }

  function DelTXTClass($IdTxtClass){
    $query ="DELETE FROM ".self::$TblPrefix."item_classes ";
    $query.="WHERE id=".$this->dbh->quote($IdTxtClass)." ";
    return(!PEAR::isError($this->dbh->query($query)));
  }

  function getTxt($IdTxt){
    $IdTxt*=1;
    $Txt=array();
    if($IdTxt!=0){
      $query ="SELECT * FROM ".self::$TblPrefix."item ";
      $query.="WHERE id=".$this->dbh->quote($IdTxt)." ";
      if(PEAR::isError($Txt=$this->dbhe->getRow($query))){
        return(FALSE);
      }
    }
    return($Txt);
  }

}
?>
